#include <stdio.h>
#include <stdlib.h>
#include <mem.h>
#include <string.h>

#define _STRMAX 79

#define BYTE unsigned char
#define MAXDEFB 8

BYTE filebuf[65536];
char labelbuf[_STRMAX+1];
BYTE sizeword[4];
BYTE pic[1024][1024];
BYTE pixrow[1024/8][8];
BYTE pixrowshift[1024/8][8]; //>>4
BYTE attrrow[1024/8];

BYTE ink;
BYTE paper;

int hgt;
int wid;
int bpp;

int readnum(FILE * fin)
{
char c;
int num;
  num = 0;
  do{
    if (!fread(&c,1,1,fin)) break;
    if ((c<'0')||(c>'9')) break; //   0x0a
    num = num*10 + (int)(c-'0');
  }while(1);
return num;
}

unsigned int readlabel(FILE * fin, char * s)
{
char c;
unsigned int i;
int iscomment;
  do{
    i = 0;
    iscomment = 0;
    do{
      if (!fread(&c,1,1,fin)) break;
      if (c == ';') iscomment = -1;
      if ((c=='=')||(c==',')) {
        if (iscomment) continue; //   =
        break;
      };
      if (c == 0x0d) continue;
      if (c == 0x0a) {
        if (iscomment) break; //    
        continue;
      };
      if (i==_STRMAX) break;
      s[i] = c;
      i++;
    }while(1);
    s[i] = '\0';
  }while(iscomment);
return i;
}

int read4b(FILE * fin)
{
  fread(sizeword, 4, 1, fin);
return sizeword[0] + (sizeword[1]<<8) + (sizeword[2]<<16) + (sizeword[3]<<24);
}

void findinkpaper(int x, int y)
{
BYTE b;
int i;
int j;
BYTE col1;
BYTE col2;
  col1 = pic[x][y];
  j = y;
  while (j < (y+8)) {
    b = 0x00;
    i = x;
    while (i < (x+8)) {
      b = pic[i][j];
      if (b!=col1) col2 = b;
      i++;
    };
    j++;
  };
  ink = col1;
  paper = col2;
}

/**                  b = 0x00;
                  i = x;
                  while (i < (x+8)) {
                    b = (BYTE)((b<<1) + (pic[i][j]&1));
                    i++;
                  };*/
void emitchr(int xchr, int y, FILE * fout)
{
BYTE b;
int j;
  fputs("\tdb ", fout);
  j = y;
  while (1) {
    b = pixrow[xchr][j];
    fprintf(fout, "0x%x%x", b>>4, b&0x0f);
    j++;
    if (j >= (y+8)) break;
    fputs(",", fout);
  };
  b = attrrow[xchr]; //0x07;
  fputs(",", fout);
  fprintf(fout, "0x%x%x", b>>4, b&0x0f);
  fputs("\n", fout);
}

void emitchrshift(int xchr, int y, FILE * fout)
{
BYTE b;
int j;
  fputs("\tdb ", fout);
  j = y;
  while (1) {
    b = pixrowshift[xchr][j];
    fprintf(fout, "0x%x%x", b>>4, b&0x0f);
    j++;
    if (j >= (y+8)) break;
    fputs(",", fout);
  };
  b = attrrow[xchr]; //0x07;
  fputs(",", fout);
  fprintf(fout, "0x%x%x", b>>4, b&0x0f);
  fputs("\n", fout);
}

void resfile(char * finname, char * fintxtname, char * foutname)
{
FILE* fin;
FILE* fintxt;
FILE* fout;
int i;
int j;
int size;
int y;
int x;

BYTE b;
BYTE b0;

BYTE curink;
BYTE curpaper;

int sprx;
int spry;
int sprwid;
int sprhgt;

  fin = fopen(finname, "rb");
  if (fin) {
    fread(filebuf, 10, 1, fin); //skip to 10 (header size)
    size = read4b(fin); //10 (header size)
    fread(filebuf, 4, 1, fin); //skip to 18
    wid = read4b(fin); //18
    hgt = read4b(fin); //22
    fread(filebuf, 2, 1, fin); //skip to 28
    fread(&bpp, 1, 1, fin); //28
    fread(filebuf, 1, size-29, fin); //skip to pic
    fintxt = fopen(fintxtname, "rb");
    if ((wid>0)&&(wid<=1024)&&(hgt>0)&&(hgt<=1024)&&((wid&7)==0)&&((hgt&7)==0)) {
      y = hgt;
      while (y>0) {
        y--;
        x = 0;
        while (x<wid) {
          fread(&b, 1, 1, fin);
          if (bpp == 8) {
            pic[x][y] = b;
            x++;
          }else {
            pic[x][y] = (BYTE)((b&0xf0)>>4);
            x++;
            pic[x][y] = (BYTE)(b&0x0f);
            x++;
          };
        };
      };

      if (fintxt) {
        fout = fopen(foutname, "wb");
        if (fout) {
/**          if (labelname[0]!='\0') {
            fputs(labelname, fout);
            fputs("\n", fout);
          };*/
          while (1) {
            size = readlabel(fintxt, labelbuf); //fread(filebuf, 1, MAXDEFB, fin);
            if (size == 0) break;
            fputs(labelbuf, fout);
            fputs("\n", fout);
            readlabel(fintxt, labelbuf); //format
            sprx = readnum(fintxt);
            spry = readnum(fintxt);
            sprwid = readnum(fintxt);
            sprhgt = readnum(fintxt);

            y = spry;
            while (y < (spry+sprhgt)) {
              //  
              curink = 7;
              curpaper = 0;
              x = sprx;
              while (x < (sprx+sprwid)) {
                findinkpaper(x,y);
                if ((ink==curink)||(paper==curpaper)) {
                  curink = ink;
                  curpaper = paper;
                }else {
                  curink = paper;
                  curpaper = ink;
                };
                j = y;
                while (j < (y+8)) {
                  b = 0x00;
                  i = x;
                  while (i < (x+8)) {
                    b = (BYTE)(b<<1);
                    if (pic[i][j]==curink) b++;
                    i++;
                  };
                  pixrow[x/8][j] = b;
                  pixrow[(x/8)+1][j] = 0x00; // 
                  j++;
                };
                attrrow[x/8] = (BYTE)(((curpaper&0x0f)<<3)+(curink&0x07));
                attrrow[(x/8)+1] = (BYTE)(((curpaper&0x0f)<<3)+(curink&0x07)); // 
                x = x+8;
              };
              //   >>4
              j = y;
              while (j < (y+8)) {
                b = 0x00;
                x = sprx;
                while (x < (sprx+sprwid+8)) {
                  b0 = pixrow[x/8][j];
                  pixrowshift[x/8][j] = (BYTE)((b<<4) + (b0>>4));
                  b = (BYTE)(b0&0x0f);
                  x = x+8;
                };
                j++;
              };

              //  
              x = sprx;
              while (x < (sprx+sprwid)) {
                emitchrshift(x/8,y,fout);
                emitchr(x/8,y,fout);
                x = x+8;
              };
              emitchrshift(x/8,y,fout);
              y = y+8;
            };

          };
          fclose(fout);
        };
        fclose(fintxt);
      };
    };
    fclose(fin);
  };
}

int main(int argc,char* argv[])
{
//  int i;
  char *finname;
  char *fintxtname;
  char *foutname;
  finname = "testpic.bmp";
  fintxtname = "testpic.txt";
  foutname = "testpic.asm";

  if (argc<4) {
    printf(
      "NedoRes\n"
      "\tnedores.exe file.bmp file.txt file.asm\n"
    );
  }else {
    finname = argv[1];
    fintxtname = argv[2];
    foutname = argv[3];
  };

  resfile(finname, fintxtname, foutname);

  return 0;
}