
#include "config.h"
#include "ethfunc.h"
#include "RamFunctions.h"
#include "opora.h"

const uint16_t MyMAC[3]={0x3412,0x7856,0xBC9A}; //MAC- 
/*const*/ uint16_t MyIPAddress[2]={0xA8C0,0x5701}; //IP-: 192.168.1.87

_Rec_Frame Frame;
uint32_t Time_old,Time_new,Time_delta;
uint16_t Counter;

//typedef struct
  union
  {
    uint8_t    buffer8[1600];
    uint16_t   buffer[800];
    uint32_t   buffer32[400];
  }  outbuf;

// uint16_t buffer[800];

void Answear_ARP(void);
void PacketAnaliser(void);
uint16_t CheckSum_IP(void);
uint16_t CheckSum_ICMP(uint16_t);
void Answear_ICMP(void);
void Answear_UDP(void);
void Request_ARP(void);
void SysTickInit(void);

void /*int*/ main()
{
        ClkConfig();
        EthernetConfig();
        PortConfig();
        SysTickInit(); //   

        WriteDataToRAM(0x60000000,0);

        if (TestData(0x60000000,0)) {
                //PORTD->SETTX=1<<7;      //  !
        }else {
                MyIPAddress[1]=0x5601; //PORTD->SETTX=1<<8;      //   !
        }
//loop:
        WriteDataToRAM(0x60000000,1);

        if(TestData(0x60000000,1)) {
                //PORTD->SETTX=1<<9;      //  !
        }else {
                MyIPAddress[1]=0x5501; //PORTD->SETTX=1<<10;     //   !
        }
 //goto loop;
        NVIC_EnableIRQ(ETHERNET_IRQn);
        while(1)
        {
                if((ETHERNET->PHY_STATUS&0x02)==0x00)   PORTB->SETTX=1<<15;             //  LINK
                else                                                                    PORTB->CLRTX=1<<15;

                if((ETHERNET->PHY_STATUS&0x08)==0x00)   PORTB->SETTX=1<<14;             //Full Duplex Mode
                else                                                                    PORTB->CLRTX=1<<14;
        }
                //Time_old=0x00FFFFFF;
}

void ETHERNET_Handler()
{
        uint16_t Status;

        Status=ETHERNET->IFR;
        ETHERNET->IFR=Status;
        Status&=0x101;
        PORTD->RXTX^=(1<<9);
        if((Status&0x01)==0x01)
        {
                PORTD->SETTX=1<<7;
                Counter=ReadPacket(&Frame);
                PacketAnaliser();
                PORTD->CLRTX=1<<7;
        }
}

//***    
void PacketAnaliser(void)
{
        switch(Frame.Data[6])  //   
    {
        case 0x0008:       // IP
                if((Frame.Data[15]==MyIPAddress[0])&&(Frame.Data[16]==MyIPAddress[1]))  // IP     
            {                                                                                 //  ,     ,
                if(CheckSum_IP()==Frame.Data[12])   //      , 
                {                                                           // -  
                                        //--------------------UDP-------------------
                        if((Frame.Data[11]&0xFF00)==0x1100)     //  : UDP
                    {
                                                        PORTD->SETTX=1<<8;
                                Answear_UDP();       //    Echo (ping) request
                                                        PORTD->CLRTX=1<<8;
                    }
                                        //--------------------ICMP-------------------
                        if((Frame.Data[11]&0xFF00)==0x0100)     //  : ICMP
                    {
                        if(Frame.Data[17]==0x0008)        //  - Echo (ping) request
                                                {
                                                        PORTD->SETTX=1<<8;
                                Answear_ICMP();       //    Echo (ping) request
                                                        PORTD->CLRTX=1<<8;
                                                }
                    }
                }
                //-------------------------------------------
            }
            break;
                case 0x0608:      // ARP
                if((Frame.Data[19]==MyIPAddress[0])&&(Frame.Data[20]==MyIPAddress[1]))  // IP     
            {                                                                                 //  ,     ,
                Answear_ARP();  //   ARP-
            }
            break;
        }
}

//***     ARP-
void Answear_ARP(void)
{
        uint16_t Buf[22];
        Buf[0]=Frame.Data[3];           //MAC- 
        Buf[1]=Frame.Data[4];           //MAC- 
        Buf[2]=Frame.Data[5];           //MAC- 
        Buf[3]=ETHERNET->MAC_T;         // MAC-
        Buf[4]=ETHERNET->MAC_M;         // MAC-
        Buf[5]=ETHERNET->MAC_H;         // MAC-
        Buf[6]=Frame.Data[6];           //type - ARP
        Buf[7]=Frame.Data[7];           //Hardware type - Ethernet
        Buf[8]=Frame.Data[8];           //Protocol type - IP
        Buf[9]=Frame.Data[9];           //Hardware size - 6; Protocol size - 4
        Buf[10]=0x0200;                 //    Who has...
        Buf[11]=ETHERNET->MAC_T;        //Sender MAC-address: 0A.1B.2C.3D.4E.5F
        Buf[12]=ETHERNET->MAC_M;        //Sender MAC-address: 0A.1B.2C.3D.4E.5F
        Buf[13]=ETHERNET->MAC_H;        //Sender MAC-address: 0A.1B.2C.3D.4E.5F
        Buf[14]=MyIPAddress[0];                 //My_IP_Address[0];    //Sender IP-address: 192.168.1.87
        Buf[15]=MyIPAddress[1];                 //My_IP_Address[1];    //Sender IP-address: 192.168.1.87
        Buf[16]=Frame.Data[3];          //Target MAC-address
        Buf[17]=Frame.Data[4];          //Target MAC-address
        Buf[18]=Frame.Data[5];          //Target MAC-address
        Buf[19]=Frame.Data[14];         //Target IP-address
        Buf[20]=Frame.Data[15];         //Target IP-address
        Buf[21]=0;

        SendPacket(Buf,42);
}

//***       IP-
uint16_t CheckSum_IP(void)
{
        unsigned long cs=0;
        cs = cs + Frame.Data[7];
        cs = cs + Frame.Data[8];
        cs = cs + Frame.Data[9];
        cs = cs + Frame.Data[10];
        cs = cs + Frame.Data[11];
        cs = cs + Frame.Data[13];
        cs = cs + Frame.Data[14];
        cs = cs + Frame.Data[15];
        cs = cs + Frame.Data[16];
        cs = (cs >> 16) + (cs & 0xFFFF);
        return (uint16_t)(~cs);
}

//***       ICMP-
//*** size - - ,      
uint16_t CheckSum_ICMP(uint16_t size)
{
        unsigned long a, cs=0;
        for(a=0;a<size;a++)
        {
                if(a==1) continue;
                else cs+=Frame.Data[a+17];
        }
        cs=(cs>>16)+(cs&0xFFFF);
        return (uint16_t)(~cs);
}

//***       ICMP
void Answear_ICMP(void)
{
    unsigned long a;
        uint16_t buffer[288];
        uint16_t tmp;

        //-   ICMP-
        tmp=Counter-34-4; //34  -  Eth2  IP , 4  -   Eth2 .
        if((tmp&0x01)==1)
        {
                tmp=(tmp+1)>>1; // -   - 
                Frame.Data[tmp+16]=Frame.Data[tmp+16]&0x00FF;
        }
        else                            tmp=tmp>>1;             // -   - 

        //-------Ethernet 2 Protocol---------
    buffer[0]=Frame.Data[3];
    buffer[1]=Frame.Data[4];
    buffer[2]=Frame.Data[5];

        buffer[3]=ETHERNET->MAC_T;
        buffer[4]=ETHERNET->MAC_M;
        buffer[5]=ETHERNET->MAC_H;

        buffer[6]=Frame.Data[6];
    //-------IP Protocol---------
    for(a=7;a<12;a++)
        {
            buffer[a]= Frame.Data[a];
    }
    //---------------------------
    buffer[12]=CheckSum_IP();
        buffer[13]=Frame.Data[15];//IP->DestinAddr[0];
        buffer[14]=Frame.Data[16];//IP->DestinAddr[1];
        buffer[15]=Frame.Data[13];//IP->SourceAddr[0];
        buffer[16]=Frame.Data[14];//IP->SourceAddr[1];
        //-------ICMP Protocol---------
        buffer[17]=0x0000; //
    Frame.Data[17]=0x0000;
        //-----------------------------
        buffer[18]=CheckSum_ICMP(tmp);
    for(a=19;a<((tmp-2)+19);a++)
        {
        buffer[a]=Frame.Data[a];
        }
        SendPacket(buffer,(tmp*2+34));
}

/*
    
   *************
................................. MAC 
 1  - MAC   () .
 2  -   -"-                              .
 3  -   -"-                              .
 4  -   -"-                              .
 5  -   -"-                              .
 6  -   -"-                              .
 7  - MAC   ()       .
 8  -   -"-                              .
 9  -   -"-                              .
 10 -   -"-                              .
 11 -   -"-                              .
 12 -   -"-                              .
 13 -  IP  (800h)                .
 14 -   -"-                              .
................................. IP 
 15 -  4,   5   (45h)
 16 -    (0)
 17 -                   .
 18 -   -"-                              .
 19 -                       .
 20 -   -"-                              .
 21 -  (0)
 22 -   (0)
 23 -  
 24 -  UDP  (11h)
 25 -   IP      .
 26 -   -"-                              .
 27 - IP                 .
 28 -   -"-                              .
 29 -   -"-                              .
 30 -   -"-                              .
 31 - IP                  .
 32 -   -"-                              .
 33 -   -"-                              .
 34 -   -"-                              .
................................. UDP 
 35 -                     .
 36 -   -"-                              .
 37 -                      .
 38 -   -"-                              .
 39 -   UDP              .
 40 -   -"-                              .
 41 -                    .
 42 -   -"-                              .
.................................  
 43 -                          .
 44 -   -"-                              .
 45 -     (.)
             0 -   
 46 -   
.................................  
   ...
...................................................
 N-(N+3) -   MAC 
*/
/*
int writetoarm(unsigned int addr,byte* mas,int bytes_in_line)
{
int i;
byte msg[300];
 cycle++;
        msg[0]=cycle>>8;
        msg[1]=cycle;
        msg[2]=0; //   
        msg[3]=0x04;
        msg[4]=bytes_in_line>>8;//0x00;
        msg[5]=bytes_in_line;//0x01;
        msg[6]=addr>>24;
        msg[7]=addr>>16;
        msg[8]=addr>>8;
        msg[9]=addr;
for(i=0;i<bytes_in_line;i++) {
        msg[10+i]=mas[i];
};
        call_dunin(msg,10+bytes_in_line);
        read_dunin(msg,10);
        addr++;
return(0);
}
*/
/*
2.1.1.      
......................................
    46 - 004h
    47-48 -   (  )
    49-52 -  (  )
    53    - . 
    ...
    N     - . 
  :
              - 
     
 .
*/
/*
    
    46 - 0f0h
    47-50 -  (  )
  :
              - 
    ,    
*/
//  1, ..   1

//***       UDP
void Answear_UDP(void)
{
unsigned long a,b, cs=0;
uint16_t tmp;
int i, n;
unsigned char * framebytes = (unsigned char *)Frame.Data;
uint32_t addr;

        if (framebytes[45]==0x04) {
                n = (framebytes[46]<<8) + framebytes[47];
                addr = (framebytes[48]<<24) + (framebytes[49]<<16) + (framebytes[50]<<8) + framebytes[51];
                for(i=0; i<n; i++) {
                        WriteByteToRAM(addr+i, framebytes[52+i]);
                };
        };
        if (framebytes[45]==0xf0) {
                //addr = 0x50000000;
                //addr = 0x20002000;
                addr = (framebytes[46]<<24) + (framebytes[47]<<16) + (framebytes[48]<<8) + framebytes[49];
                CallRAM(addr);
        };

//                uint32_t *buf32, *buf321;
                Time_new=SysTick->VAL&0x00FFFFFF; //    
                if((SysTick->CTRL&0x10000)==0x10000)
                {
                        Time_delta=(0x00FFFFFF+Time_old-Time_new);
                }
                else
                {
                        Time_delta=(Time_old-Time_new);
                };
                outbuf.buffer[21]=(uint16_t)((Time_delta&0xFFFF0000)>>16); //     -  
                outbuf.buffer[22]=(uint16_t)(Time_delta&0x0000FFFF); //     -  
                Time_old=Time_new;
        //-   ICMP-
        tmp=Counter-34-4; //34  -  Eth2  IP , 4  -   Eth2 .
        if((tmp&0x01)==1) //   - 
        {
                tmp=(tmp+1)>>1; // -   -   UDP-
                Frame.Data[tmp+16]=Frame.Data[tmp+16]&0x00FF; //      
        }
        else                            tmp=tmp>>1;             // -   -   UDP-

        //-------Ethernet 2 Protocol---------
        outbuf.buffer[0]=Frame.Data[3];
        outbuf.buffer[1]=Frame.Data[4];
        outbuf.buffer[2]=Frame.Data[5];

        outbuf.buffer[3]=ETHERNET->MAC_T;
        outbuf.buffer[4]=ETHERNET->MAC_M;
        outbuf.buffer[5]=ETHERNET->MAC_H;

        outbuf.buffer[6]=Frame.Data[6];
    //-------IP Protocol---------
        outbuf.buffer[7]=Frame.Data[7];
        outbuf.buffer[8]=Frame.Data[8];
        outbuf.buffer[9]=Frame.Data[9];
        outbuf.buffer[10]=Frame.Data[10];
        outbuf.buffer[11]=Frame.Data[11];
        outbuf.buffer[13]=Frame.Data[15];//IP->DestinAddr[0];
        outbuf.buffer[14]=Frame.Data[16];//IP->DestinAddr[1];
        outbuf.buffer[15]=Frame.Data[13];//IP->SourceAddr[0];
        outbuf.buffer[16]=Frame.Data[14];//IP->SourceAddr[1];
    //-----------    IP-----------------
                cs = cs + outbuf.buffer[7];
                cs = cs + outbuf.buffer[8];
                cs = cs + outbuf.buffer[9];
                cs = cs + outbuf.buffer[10];
                cs = cs + outbuf.buffer[11];
                cs = cs + outbuf.buffer[13];
                cs = cs + outbuf.buffer[14];
                cs = cs + outbuf.buffer[15];
                cs = cs + outbuf.buffer[16];
        cs = (cs >> 16) + (cs & 0xFFFF);
        outbuf.buffer[12]=(uint16_t)(~cs);
//              outbuf.buffer[12]=CheckSum_IP();
        //-------UDP Protocol---------
        outbuf.buffer[17]=Frame.Data[18];// 
        outbuf.buffer[18]=Frame.Data[17];// 
        outbuf.buffer[19]=Frame.Data[19];// UDP
        outbuf.buffer[20]=0x0000; //  
        //-----------------------------
        // outbuf.buffer[18]=CheckSum_ICMP(tmp);
                tmp=tmp+17; //    
//                buf321=(uint32_t*)(Frame.Data[25]);
//                buf32=(uint32_t*)(outbuf.buffer[25]);
        outbuf.buffer[25]=Frame.Data[25];
                b=tmp/2;
    for(a=13;a<b;a++) //   
        {
        outbuf.buffer32[a]=Frame.Data32[a];
        a++;
        outbuf.buffer32[a]=Frame.Data32[a];
        a++;
        outbuf.buffer32[a]=Frame.Data32[a];
        a++;
        outbuf.buffer32[a]=Frame.Data32[a];
        };
//         /*{
//        buf321=(uint32_t*)(Frame.Data[a]);
//       buf32=(uint32_t*)(outbuf.buffer[a]);
//        *(buf32)=(uint32_t)a;//*(buf321);
//        a++;
//        *(buf32++)=*(buf321++);
//        a++;
//        *(buf32++)=*(buf321++);
//        a++;
//        *(buf32++)=*(buf321++);
//        }
//      for(a=25;a<tmp;a++)
//        {
//        outbuf.buffer[a]=Frame.Data[a];
//        a++;
//        outbuf.buffer[a]=Frame.Data[a];
//        a++;
//        outbuf.buffer[a]=Frame.Data[a];
//        a++;
//        outbuf.buffer[a]=Frame.Data[a];
//        }  */
                Time_new=SysTick->VAL&0x00FFFFFF; //    
                if((SysTick->CTRL&0x10000)==0x10000)
                {
                        Time_delta=(0x00FFFFFF+Time_old-Time_new);
                }
                else
                {
                        Time_delta=(Time_old-Time_new);
                };
                outbuf.buffer[23]=(uint16_t)((Time_delta&0xFFFF0000)>>16); // - ,    -  
                outbuf.buffer[24]=(uint16_t)(Time_delta&0x0000FFFF); // - ,    -  
        SendPacket(outbuf.buffer,(tmp*2));
}

//--- System Timer initialization ---
void SysTickInit() //   
{
        SysTick->LOAD = 0x00FFFFFF;     //Pause 177 ms (HCLK = 96MHz)
        SysTick->CTRL = 0x00000001;     //Enabel SysTick
}
